(function ($) {
   'use strict';

   //First execution
   if (!localStorage['settings.pais']) {
      location.hash = '#prerequisite';
      $('#prerequisite').addClass('ui-page-active');
   }

   $(document)
      .on('pageinit', function (e) {
         //Add a placeholder for date input fields if doesnt support it, Android until 4.1.1
         if (!Modernizr.inputtypes.date) {
            $('input[type="date"]').attr('placeholder', 'aaaa-mm-dd');
         }
      })
      .on('pageshow', function (e) {
         //Track page navigation
         if (typeof window.analytics != 'undefined') {
			window.analytics.trackView($.url().attr('file'));
		 }
      })
      .on('deviceready', function () {
         if (device.platform == 'Android') {
            //Fixes for Android 2.*	bugs		
            if (device.version.indexOf('2') == 0) {
               //Slide transition do page flick or blink, bug fixed at 4.4 version
               $.mobile.defaultPageTransition = 'none';
            }

            //Fixes for Android 4.0.*, 4.1.* bugs
            if (device.version.indexOf('4.0') == 0 || device.version.indexOf('4.1') == 0) {
               //Fix for input type number for Android 4.0, 4.1, bug fixed at 4.2.2 version
               $(document).on('pageinit', function (e) {
                  $("input[type='number']").each(function (i, el) {
                     el.type = "text";
                     el.onfocus = function () {
                        this.type = "number";
                     };
                     el.onblur = function () {
                        this.type = "text";
                     };
                  });
               });

               //Slide transition do page flick or blink, bug fixed at 4.4 version
               $.mobile.defaultPageTransition = 'none';
            }

            //Si el dispositivo no soporta los campos fecha por defecto usamos un plugin
            //Android 4.1 devuelve true pero no despliega el calendario
            //En Android 4.0 se cierra la aplicacion al abrir el calendario
            if (device.version.indexOf('4.0') != 0 && (!Modernizr.inputtypes.date || device.version.indexOf('4.1') == 0)) {
               $(document).on('tap', 'input[type="date"]', function () {
                  var options = {
                        date: new Date(),
                        mode: 'date'
                     },
                     self = $(this);

                  datePicker.show(options, function (date) {
                     self.val('{0}-{1}-{2}'.format(date.getFullYear(), date.getMonth() + 1, date.getDate()));
                  });
               });
            }
         }
         /*
			//Agrega espacio adicional en la parte superior para q se presente correctamente en iOS 7+
			if(device.platform=='iOS') {
				//Fix for extra 20px at the top in ios7
				if (device.version.indexOf('7')==0) {
					$('body').addClass('ios7');
				}
			}
			*/

         //Google analytics
         if (typeof window.analytics != 'undefined') {
			window.analytics.startTrackerWithId(config.googleTrackingId);
	     }
      })
      .on('mobileinit', function () {
         //Default jquery mobile properties
         $.extend($.mobile, {
            defaultPageTransition: 'slide',
            defaultDialogTransition: 'none',
            pushStateEnabled: false
               //phonegapNavigationEnabled: true //Use only if pages was not load via ajax, show and error for "backHistory is undefined" on Android 4.0, 4.1
         });
         $.extend($.mobile.page.prototype.options, {
            backBtnText: "Atrás",
            domCache: true,
            addBackBtn: true
         });

         //Iframe to load files
         var $iframe = $('<iframe style="display:none;" />').appendTo('body');

         //Open external urls
         $(document).on('click', '[data-id="second-nav"] a', function (e) {
            var $this = $(this),
               url = $this.attr('href');
            if (url == 'external.html?opcion=07&title=Beneficios' || url == 'external.html?opcion=11&title=Aliados') {
               var urlObj = $.url(url);

               e.preventDefault();
               $.mobile.loading('show');
               dataService.getAfiliadosSimanWs({
                     opcion: urlObj.param('opcion')
                  })
                  .done(function (response) {
                     if (response.res == 'T') {
                        var externalUrl = response.url.indexOf('http://') == 0 || response.url.indexOf('https://') == 0 ? response.url : 'http://' + response.url;
                        if (device.platform == 'Android' && externalUrl.lastIndexOf('pdf') == externalUrl.length - 3) {
                           //Abre archivos PDF en un navegador externo en dispositivos Android
                           //window.open(externalUrl, '_system');
                           /*
                           window.plugins.webintent.startActivity({
                                 action: window.plugins.webintent.ACTION_VIEW,
                                 url: externalUrl,
                                 type: 'application/pdf'
                              },
                              function () {},
                              function () {
                                 alert('Hubo un problema al cargar el archivo.');
                              }
                           );
                           */
                           window.open('https://docs.google.com/viewer?embedded=true&url='+encodeURIComponent(externalUrl), '_system');
                        } else {
                           window.open(externalUrl, '_blank');
                           //window.plugins.ChildBrowser.showWebPage(externalUrl, { showLocationBar: true });
                        }
                     } else {
                        App.alert(response.msg);
                     }
                  })
                  .always(function () {
                     $this.removeClass('ui-btn-active');
                     $.mobile.loading('hide');
                  });
            }
         })
      })
      .on('ready', function () {
         //Validation
         $.validator.setDefaults({
            errorPlacement: function (error, element) {
               var $controlGroup = element.closest('.form-group');
               $controlGroup.addClass('validate');
               if (!error.is(':empty')) {
                  error.appendTo($controlGroup);
               }
            },
            success: $.noop
         });

         //Ajax setup
         $.ajaxSetup({
            timeout: config.ajaxTimeout,
            error: function (jqXHR, textStatus, errorThrown) {
               if (textStatus == 'timeout') {
                  App.alert('No es posible realizar la consulta, favor intentar nuevamente más tarde.');
               } else if (textStatus == 'error' && jqXHR.status == 0) {
                  App.alert('Hubo un error inesperado. Asegurese que su conexión a Internet esté habilitada y vuelva a intentar.');
               } else {
                  App.alert(textStatus + ': ' + errorThrown + ' (' + jqXHR.status + ')');
               }
            }
         });
      });

   //Plugins
   $.fn.serializeObject = function () {
      "use strict";

      var result = {},
         extend = function (i, element) {
            var node = result[element.name];

            // If node with same name exists already, need to convert it to an array as it
            // is a multi-value field (i.e., checkboxes)
            if ('undefined' !== typeof node && node !== null) {
               if ($.isArray(node)) {
                  node.push(element.value);
               } else {
                  result[element.name] = [node, element.value];
               }
            } else {
               result[element.name] = element.value;
            }
         };

      $.each(this.serializeArray(), extend);
      return result;
   };

   //Extend
   String.prototype.format = function () {
      var s = this,
         i = arguments.length;

      while (i--) {
         s = s.replace(new RegExp('\\{' + i + '\\}', 'gm'), arguments[i]);
      }
      return s;
   };
   Number.prototype.format = function (c, d, t) {
      var n = this,
         c = isNaN(c = Math.abs(c)) ? 2 : c,
         d = d == undefined ? "." : d,
         t = t == undefined ? "," : t,
         s = n < 0 ? "-" : "",
         i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "",
         j = (j = i.length) > 3 ? j % 3 : 0;
      return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
   };

   //Jquery Validate fix for date inputs
   var originalDateValidator1 = $.validator.methods.date;
   var originalDateValidator2 = $.validator.methods.dateISO;

   $.validator.methods.date = function (value, element) {
      var isValidDate =
         originalDateValidator1.apply(this, arguments) ||
         originalDateValidator2.apply(this, arguments);

      return isValidDate;
   };
})(jQuery);

//App
(function ($) {
   'use strict';

   window.App = (function () {
      //Private 
      var cordovaRef = window.PhoneGap || window.cordova || window.Cordova;

      //Public 
      return {
         alert: function (message) {
            if (typeof cordovaRef !== "undefined") {
               navigator.notification.alert(message, null, config.app.name);
            } else {
               alert(message);
            }
         }
      }
   })();
})(jQuery);

//Form
(function ($) {
   'use strict';

   window.Form = (function () {
      //Private 

      //Public 
      return {
         ajaxSubmit: function ($form, status) {
            if (status == 1) {
               $form.find('.ui-input-text, .ui-input-search, .ui-select').addClass('disabled').end().find(':input').attr('disabled', 'disabled');
               $.mobile.loading('show');
            } else {
               $form.find('.ui-input-text, .ui-input-search, .ui-select').removeClass('disabled').end().find(':input').removeAttr('disabled');
               $.mobile.loading('hide');
            }
         },
         reset: function ($form) {
            $form.each(function () {
               this.reset();
            });
            if ($form.data('validator')) {
               $form.data('validator').resetForm();
            }
         }
      }
   })();
})(jQuery);