(function($){
	'use strict';
	
	$.validator.addMethod('cuenta', function(value, element){
		if (typeof value == 'number') {
			value = value.toString();
		}
		//Validación para números de tarjeta antiguos
		if (value.length==12) {
			var isValid = false;
			switch($(element).data('type')) {
				case 'rombos':
					isValid = value.indexOf('01')==0;
					break;
				case 'monedero':
				case 'certificado':
					isValid = value.indexOf('50')==0 || value.indexOf('51')==0;
					break;
			}
			return isValid;
		}
		//Validación para números de tarjeta nuevos
		if (value.length!=16) {
			return false;
		}
		if (!isNaN(value)) {
			var values = [
				value.charAt(0) * 2,
				value.charAt(1) * 1,
				value.charAt(2) * 2,
				value.charAt(3) * 1,
				value.charAt(4) * 2,
				value.charAt(5) * 1,
				value.charAt(6) * 2,
				value.charAt(7) * 1,
				value.charAt(8) * 2,
				value.charAt(9) * 1,
				value.charAt(10) * 2,
				value.charAt(11) * 1,
				value.charAt(12) * 2,
				value.charAt(13) * 1,
				value.charAt(14) * 2
			];
			
			var t = 0;
			$.each(values, function(){
				var d = this;
				if (this>9) {
					var p = this.toString();
					d = Number(p.charAt(0)) + Number(p.charAt(1));
				}
				t += d;	
			});
			var u = Math.ceil(t/10)*10;
			var v = u-t;
			
			return value.charAt(15) == v;
		}
	}, 'Número de cuenta inválido.');
})(jQuery);