(function($){
	'use strict';
	
	var endpoint = config.debug.enabled && localStorage['settings.entorno']? localStorage['settings.entorno'] : config.endpoint;
	
	window.DataService = window.dataService = {
		getAfiliadosSimanWs: function(data) {
			return $.ajax({
				url:endpoint+'getAfiliadosSimanWs/',
				data:JSON.stringify($.extend({
					cadena: config.cadena,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}, data)),
				method:'POST'
			});
		},
		getConsultaUsuarioCredisiman: function(data) {
			return $.ajax({
				url:endpoint+'getConsultaUsuarioCredisiman/',
				data:JSON.stringify($.extend({
					cadena: config.cadena,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}, data)),
				method:'POST'
			});
		},
		getCorreosAppWs: function(data) {
			return $.ajax({
				url:endpoint+'getCorreosAppWs/',
				data:JSON.stringify($.extend({
					cadena: config.cadena,
					pais: localStorage['settings.pais'],
					opcion:'06',
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}, data)),
				method:'POST'
			});
		},
		getConsultaSaldosCredisimanWs: function(data) {
			return $.ajax({
				url:endpoint+'getConsultaSaldosCredisimanWs/',
				data:JSON.stringify({
					numeroTarjeta: Utils.encrypt(data.numeroTarjeta),
					cadena: config.cadena,
					opcion: data.opcion,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}),
				method:'POST'
			});
		},
		getConsultaListaRombosPremios: function(data) {
			return $.ajax({
				url:endpoint+'getConsultaListaRombosPremios/',
				data:JSON.stringify({
					numeroTarjeta: Utils.encrypt(data.numeroTarjeta),
					cadena: config.cadena,
					opcion: '09',
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip,
					registroinicio:data.firstRegister,
					registrofin:data.lastRegister
				}),
				method:'POST'
			});
		},
		getConsultadeSaldosMonedero: function(data) {
			return $.ajax({
				url:endpoint+'getConsultadeSaldosMonedero/',
				data:JSON.stringify({
					numeroTarjeta: Utils.encrypt(data.numeroTarjeta),
					cadena: config.cadena,
					opcion: '03',
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}),
				method:'POST'
			});
		},
		getConsultadeSaldosCertificado: function(data) {
			return $.ajax({
				url:endpoint+'getConsultadeSaldosCertificado/',
				data:JSON.stringify({
					numeroTarjeta: Utils.encrypt(data.numeroTarjeta),
					cadena: config.cadena,
					opcion: '04',
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}),
				method:'POST'
			});
		},
		getEvents: function(data) {
			return $.ajax({
				url:endpoint+'getEvents/',
				data:JSON.stringify({
					eventTypeId:data.eventTypeId,
					eventId:data.eventId? data.eventId : 0,
					eventDate:data.eventDate? data.eventDate : '',
					eventNames:data.eventNames? data.eventNames : '',
					cancelled: "0",
					registroInicio:data.registroInicio,
					registroFin:data.registroFin,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip:config.ip
				}),
				method:'POST'
			});
		},
		getTotalRegistrosEventos: function(data) {
			return $.ajax({
				url:endpoint+'getTotalRegistrosEventos/',
				data:JSON.stringify({
					eventTypeId:data.eventTypeId,
					eventId:data.eventId? data.eventId : 0,
					eventDate:data.eventDate? data.eventDate : '',
					cancelled: "0",
					eventNames:data.eventNames? data.eventNames : '',
					opcion:data.opcion,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip:config.ip
				}),
				method:'POST'
			});
		},
		getListadoDeRegalos: function(data) {
			return $.ajax({
				url:endpoint+'getListadoDeRegalos/',
				data:JSON.stringify({
					numeroEvento: data.numeroEvento,
					registroInicio:data.registroInicio,
					registroFin:data.registroFin,
					pais: localStorage['settings.pais'],
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip				  
				}),
				method:'POST'
			});
		},
		getListadoPaises : function(data) {
			return $.ajax({
				url:endpoint+'getListadoPaises/',
				data:JSON.stringify({
					cadena: config.cadena,
					usuario: config.usuario,
					clave: config.clave,
					ip: config.ip
				}),
				method:'POST'
			});
		},
		
		//Local data
		setSettings: function(data) {
			var deferred = $.Deferred();
			$.each(data, function(key, value) {
				endpoint = localStorage['settings.'+key] = value;
			});		
			deferred.resolve();
				
			return deferred.promise(); 
		},
		getCurrencySymbol: function() {
			var currencySymbol;
			$.each(config.countries, function(){
				if (this.a2==localStorage['settings.pais']) {
					currencySymbol = this.currencySymbol;
				}
			});
			return currencySymbol;
		}
	};
})(jQuery);