(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]'), //Contexto
		viewModel = {
			editing:ko.observable(false),
			balance:ko.observable(),
			getBalance: function (form) {
				if (!viewModel.pendingRequest() && $(form).valid()) {
					viewModel.balance(null);
					dataService.getConsultaSaldosCredisimanWs($(form).serializeObject())
						.done(function(response){
							if (response.res=='T') {
								viewModel.balance(Utils.decrypt(response.saldoActualGlobal));
							}else{
								App.alert(response.msg);
							}
						})
						.always(function(){
							viewModel.pendingRequest(false);
							Form.ajaxSubmit($page, 0);
						});
					viewModel.pendingRequest(true);
					Form.ajaxSubmit($page, 1);				
				}
			},
			pendingRequest: ko.observable(false)
		};

    $page
		.on('pageinit', function (e) {
			$page.find('#query-form').validate(); //Inicializa control de validación en cliente;			
			ko.applyBindings(viewModel, $page[0]);	//Inicializa binding con la vista
		})
		.on('pagebeforeshow', function(e){
			Form.reset($page.find('form'));
			viewModel.balance(null);
		});
})(jQuery);