﻿(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]'), //Contexto
		currentQueryKey,
		queryKey,
		viewModel = {
			terms: ko.observableArray(),
			getTerms: function(){
				if (config.credisiman && config.credisiman.numeroTarjeta) {
					var numeroTarjeta = config.credisiman.numeroTarjeta,
						queryKey = localStorage['settings.pais']+config.credisiman.numeroTarjeta;
						
					dataService.getConsultaSaldosCredisimanWs({numeroTarjeta:Utils.decrypt(numeroTarjeta), opcion:'08'})
						.done(function(terms){
							if (terms.res=='T') {
								currentQueryKey = queryKey;
								if (!Array.isArray(terms.datosCon)) {
									viewModel.terms([getTermObject(terms.datosCon.datosPlazos)]);	
								}else{
									var t = [];
									$.each(terms.datosCon, function(){
										t.push(getTermObject(this));
									})
									viewModel.terms(t);
								}
							}else{
								App.alert(terms.msg);
							}
						})
						.always(function(){
							Form.ajaxSubmit($page, 0);
						});
					Form.ajaxSubmit($page, 1);					
				}else{
					$(":mobile-pagecontainer").pagecontainer( "change", 'login.html');
					//$.mobile.navigate('login.html');
				}
			},
			logout: function(){
				delete config.credisiman.numeroTarjeta;
				$(":mobile-pagecontainer").pagecontainer( "change", 'login.html');
				//$.mobile.navigate('login.html');
			}
		},
		getTermObject = function(terms){
			return {
				numeroTarjeta: Utils.decrypt(terms.numeroTarjeta),
				nombreCliente: terms.nombreCliente,
				fechaAprobacion: Utils.decrypt(terms.fechaAprobacion),
				montoAprobado: Utils.decrypt(terms.montoAprobado),
				montoCuota: Utils.decrypt(terms.montoCuota),
				fechaPago: Utils.decrypt(terms.fechaPago),
				cuotasContratadas: Utils.decrypt(terms.cuotasContratadas),
				saldoActual: Utils.decrypt(terms.saldoActual),
				saldoVencido: Utils.decrypt(terms.saldoVencido)
			}
		};

    $page
		.on('pagebeforecreate', function(e) {
			ko.applyBindings(viewModel, $page[0]);
		})
		.on('pagebeforeshow', function(e) {
			var queryKey = localStorage['settings.pais']+config.credisiman.numeroTarjeta;
			if (currentQueryKey != queryKey) {
				viewModel.terms([]);
			}
		})
		.on('pageshow', function(e) {
			viewModel.getTerms();
		});
})(jQuery);