﻿(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]'), //Contexto
		currentQueryKey,
		queryKey,
		viewModel = {
			balance: ko.observable(),
			currencySymbol: ko.computed(function(){
				return dataService.getCurrencySymbol();
			}),
			getBalance: function(){
				if (config.credisiman && config.credisiman.numeroTarjeta) {
					var numeroTarjeta = config.credisiman.numeroTarjeta,
						queryKey = localStorage['settings.pais']+config.credisiman.numeroTarjeta;
					
					dataService.getConsultaSaldosCredisimanWs({numeroTarjeta:Utils.decrypt(numeroTarjeta), opcion:'01'})
						.done(function(balance){
							if (balance.res=='T') {
								currentQueryKey = queryKey;
								viewModel.balance({
									numeroTarjeta: Utils.decrypt(balance.numeroTarjeta),
									nombreCliente: balance.nombreCliente,
									saldoActualGlobal: Utils.decrypt(balance.saldoActualGlobal),
									limiteCredito: Utils.decrypt(balance.limiteCredito),
									pagoMinimo: Utils.decrypt(balance.pagoMinimo),
									fechaLimitePago: Utils.decrypt(balance.fechaLimitePago),
									saldoActualCcr: Utils.decrypt(balance.saldoActualCcr),
									disponibleCcr: Utils.decrypt(balance.disponibleCcr)
								});
							}else{
								App.alert(balance.msg);
							}
						})
						.always(function(){
							Form.ajaxSubmit($page, 0);
						});
					Form.ajaxSubmit($page, 1);					
				}else{
					$(":mobile-pagecontainer").pagecontainer( "change", 'login.html');
					//$.mobile.navigate('login.html');
				}
			},
			logout: function(){
				delete config.credisiman.numeroTarjeta;
				$(":mobile-pagecontainer").pagecontainer( "change", 'login.html');
				//$.mobile.navigate('login.html');
			}
		};

    $page
		.on('pagebeforecreate', function(e) {
			ko.applyBindings(viewModel, $page[0]);
		})
		.on('pagebeforeshow', function (e) {
			var queryKey = localStorage['settings.pais']+config.credisiman.numeroTarjeta;
			if (currentQueryKey != queryKey) {
				viewModel.balance(null);
			}	
		})
		.on('pageshow', function(e) {
			viewModel.getBalance();
		});
})(jQuery);