(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]'), //Contexto
		viewModel = {
			limits:{
				registroInicio:1,
				registroFin:config.pageSize,
			},
			gifts:ko.observableArray(),
			totalGifts:ko.observable(-1),
			numeroEvento:ko.observable(),
			nombreEvento:ko.observable(),
			getGifts: function () {
				if (!viewModel.pendingRequest()) {
					dataService.getListadoDeRegalos($.extend({numeroEvento:viewModel.numeroEvento()}, viewModel.limits))
						.done(function(response){
							try {
								if (response.res=='T') {
									viewModel.nombreEvento(response.nombreEvento);
									$.each(response.eventsList, function(){
										viewModel.gifts.push(this);
									});
									viewModel.limits.registroInicio += config.pageSize;
									viewModel.limits.registroFin += config.pageSize;
								}else{
									App.alert(response.msg);
									if ($.mobile.activePage && $page[0] == $.mobile.activePage[0] && viewModel.limits.registroInicio==1) $.mobile.back();	
								}
							}catch (e){
								//App.alert(e.message);
							}
						})
						.always(function(){
							viewModel.pendingRequest(false);
							$.mobile.loading('hide');
						});
					viewModel.pendingRequest(true);
					$.mobile.loading('show');				
				}
			},
			getFirstGifts: function(form){
				viewModel.limits = {registroInicio:1, registroFin:config.pageSize};
				dataService.getTotalRegistrosEventos({opcion:'99', eventId:viewModel.numeroEvento()}).done(function(response){
					if (response.res=='T') {
						viewModel.totalGifts(response.totalRegistros);
					}else{
						//App.alert(response.msg);
					}
				});
				viewModel.getGifts();
			},
			mapParams: function() {
				var pageUrl = $.url($page.data('url')),
					documentUrl = $.url(location.href);
				viewModel.numeroEvento(pageUrl.param('numeroEvento') || documentUrl.param('numeroEvento'));
			},
			pendingRequest: ko.observable(false),
			state:{
				searchType:ko.observable()
			}
		};

    $page
		.on('pageinit', function (e) {
			ko.applyBindings(viewModel, $page[0]);
		})
		.on('pagebeforeshow', function (e) {
			viewModel.gifts([]);
			viewModel.nombreEvento('');
		})
		.on('pageshow', function (e) {		
			viewModel.mapParams();
			viewModel.getFirstGifts();
		});
})(jQuery);