(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]'), //Contexto
		viewModel = {
			eventTypeId:ko.observable(),
			limits:{
				registroInicio:1,
				registroFin:config.pageSize,
			},
			searchTypes: config.events.searchTypes,
			events:ko.observableArray(),
			totalEvents:ko.observable(-1),
			getEvents: function (form) {
				if (!viewModel.pendingRequest()) {
					var data = $(form).serializeObject(),
						eventDateArray = data.eventDate? data.eventDate.split('-') : '',
						eventDate = data.eventDate? '{0}/{1}/{2}'.format(eventDateArray[2], eventDateArray[1], eventDateArray[0]) : '';
					dataService.getEvents($.extend({}, data, viewModel.limits, {eventDate:eventDate}))
						.done(function(response){
							if (response.res=='T') {
								$.each(response.eventsList, function(){
									viewModel.events.push(this);
								});
								viewModel.limits.registroInicio += config.pageSize;
								viewModel.limits.registroFin += config.pageSize;
							}else{
								App.alert(response.msg);
							}
						})
						.always(function(){
							viewModel.pendingRequest(false);
							Form.ajaxSubmit($(form), 0);
						});
					viewModel.pendingRequest(true);
					Form.ajaxSubmit($(form), 1);				
				}
			},
			getFirstEvents: function(form){
				if ($(form).valid()) {
					var data = $(form).serializeObject(),
						eventDateArray = data.eventDate? data.eventDate.split('-') : '',
						eventDate = data.eventDate? '{0}/{1}/{2}'.format(eventDateArray[2], eventDateArray[1], eventDateArray[0]) : '';
					viewModel.limits = {registroInicio:1, registroFin:config.pageSize};
					dataService.getTotalRegistrosEventos($.extend({opcion:'05'}, data, {eventDate:eventDate})).done(function(response){
						if (response.res=='T') {
							viewModel.totalEvents(response.totalRegistros);
						}else{
							//App.alert(response.msg);
						}
					});
					viewModel.events([]);
					viewModel.getEvents(form);
				}
			},
			getMoreEvents: function(){
				var form = $page.find('#filters');
				viewModel.getEvents(form);
			},
			mapParams: function() {
				var pageUrl = $.url($page.data('url')),
					documentUrl = $.url(location.href);
				viewModel.eventTypeId(pageUrl.param('eventTypeId') || documentUrl.param('eventTypeId'));
			},
			pendingRequest: ko.observable(false),
			state:{
				searchType:ko.observable()
			}
		};
	viewModel.state.searchType(viewModel.searchTypes[0]);

    $page
		.on('pageinit', function (e) {
			viewModel.mapParams();		
			ko.applyBindings(viewModel, $page[0]);
			$page.find('form').validate(); //Inicializa control de validación en cliente;
			$.mobile.loadPage('event-gifts.html');
		})
		.on('pagebeforeshow pagebeforehide', function (e, data) {
			if (e.type=='pagebeforeshow' && data.prevPage.attr('id')!='event-gifts') {
				viewModel.events([]);
				viewModel.state.searchType(viewModel.searchTypes[0]);
				$page.find('.middle').hide();
				Form.reset($page.find('form'));
				//$page.find('select').selectmenu("refresh");
			}
		})
		.on('pageshow', function (e) {
			if (viewModel.events().length==0) $page.find('.middle').fadeIn();
		});
})(jQuery);		