(function ($) { //Closure
    'use strict';

    var $page = $($('script').last()).closest('[data-role="page"]');
		window.viewModel = {
			paises: ko.observableArray(),
			settings: {
				pais:ko.observable(),
				entorno:ko.observable(),
				version:config.app.version
			},
			setSettings: function(form){
				if ($(form).valid()) {
					var settings = $(form).serializeObject(),
						currentSettingsEntorno = localStorage['settings.entorno'];
					//Limpia la tarjeta credisiman si se cambia de pais
					if (settings.pais!=localStorage['settings.pais'] && config.credisiman && config.credisiman.numeroTarjeta) {
						delete config.credisiman.numeroTarjeta;
					}
					dataService.setSettings(settings)
						.done(function(response){
							App.alert('La configuración ha cambiado exitosamente.');
							//Vuelve a cargar la configuracion si a cambiado la variable de entorno
							if (settings.entorno!=currentSettingsEntorno) {
								viewModel.init();
							}
						});					
				}
			},
			init: function(){
				dataService.getListadoPaises()
					.done(function(paises){						
						if (paises.res=='T') {
							viewModel.paises(paises.listadoPaises);
							viewModel.settings.pais(localStorage['settings.pais']);
							$page.find('[name="pais"]').selectmenu("refresh");
							viewModel.settings.entorno(localStorage['settings.entorno']);
							$page.find('[name="entorno"]').selectmenu("refresh");
						}else{
							App.alert(paises.msg);
						}
					})
					.fail(function() {
						if ($.mobile.activePage && $page[0] == $.mobile.activePage[0]) $.mobile.back();	
						if (config.debug.enabled) {
							dataService.setSettings({entorno:config.endpoint});
							viewModel.paises([]);
						}
					})
					.always(function(){
						Form.ajaxSubmit($page, 0);
					});
				Form.ajaxSubmit($page, 1);
			}
		};

    $page
		.on('pageinit', function (e) {
			ko.applyBindings(viewModel, $page[0]);
		})
		.on('pageshow', function (e) {
			if (viewModel.paises().length==0) viewModel.init();
		})
		.validate(); //Inicializa control de validación en cliente;

})(jQuery);